using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using Syncfusion.Windows.Forms.Grid;

namespace WindowsApplication1
{
	public class Form1 : System.Windows.Forms.Form
	{
		private System.ComponentModel.Container components = null;
		private Syncfusion.Windows.Forms.Grid.GridControl m_grid;
		DClassCodeLookupList m_classLookup;
		int[] m_values;

		[STAThread] static void Main() { Application.Run(new Form1()); }

		public Form1()
		{
			InitializeComponent();

			//Initialize bogus test data

			m_classLookup = new DClassCodeLookupList();
			m_classLookup.Add(new DClassCodeLookup(0,"Unclassified"));
			m_classLookup.Add(new DClassCodeLookup(1,"Black"));
			m_classLookup.Add(new DClassCodeLookup(2,"White"));
			m_classLookup.Add(new DClassCodeLookup(3,"Red"));
			m_classLookup.Add(new DClassCodeLookup(4,"Green"));
			m_classLookup.Add(new DClassCodeLookup(5,"Blue"));
			m_classLookup.Add(new DClassCodeLookup(6,"Cyan"));
			m_classLookup.Add(new DClassCodeLookup(7,"Magenta"));
			m_classLookup.Add(new DClassCodeLookup(8,"Yellow"));

			m_values = new int[]{1,0,9,8,2,3,9,0,8,7,0,2,7,3,2,1};

			//Define columm styles

			m_grid.RowHeights[0] = 30;

			m_grid[0,1].Text = "Class Number";
			m_grid.ColStyles[1].CellType     = "TextBox";
			m_grid.ColStyles[1].CellValueType = typeof(int);
			m_grid.ColWidths[1] = 60;

			m_grid[0,2].Text = "Class Name";
			m_grid.ColStyles[2].CellType     = "ComboBox";
			m_grid.ColStyles[2].DropDownStyle= GridDropDownStyle.AutoComplete;
			m_grid.ColStyles[2].DataSource   = m_classLookup;
			m_grid.ColStyles[2].DisplayMember= "ClassName";
			m_grid.ColStyles[2].ValueMember  = "ClassNumber";
			m_grid.ColStyles[2].ShowButtons  = GridShowButtons.ShowCurrentCellEditing;
			m_grid.ColStyles[2].CellValueType = typeof(string);
			m_grid.ColWidths[2] = 80;
		}

		protected override void Dispose( bool disposing )
		{
			if( disposing && components != null) components.Dispose();
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.m_grid = new Syncfusion.Windows.Forms.Grid.GridControl();
			((System.ComponentModel.ISupportInitialize)(this.m_grid)).BeginInit();
			this.SuspendLayout();
			// 
			// m_grid
			// 
			this.m_grid.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
			this.m_grid.ColCount = 2;
			this.m_grid.DefaultRowHeight = 15;
			this.m_grid.Dock = System.Windows.Forms.DockStyle.Fill;
			this.m_grid.EnterKeyBehavior = Syncfusion.Windows.Forms.Grid.GridDirectionType.Down;
			this.m_grid.Location = new System.Drawing.Point(0, 0);
			this.m_grid.Name = "m_grid";
			this.m_grid.NumberedColHeaders = false;
			this.m_grid.RefreshCurrentCellBehavior = Syncfusion.Windows.Forms.Grid.GridRefreshCurrentCellBehavior.RefreshRow;
			this.m_grid.RowCount = 16;
			this.m_grid.Size = new System.Drawing.Size(203, 267);
			this.m_grid.SmartSizeBox = false;
			this.m_grid.TabIndex = 0;
			this.m_grid.Text = "m_grid";
			this.m_grid.QueryRowCount += new Syncfusion.Windows.Forms.Grid.GridRowColCountEventHandler(this.m_grid_QueryRowCount);
			this.m_grid.QueryCellInfo += new Syncfusion.Windows.Forms.Grid.GridQueryCellInfoEventHandler(this.m_grid_QueryCellInfo);
			this.m_grid.SaveCellInfo += new Syncfusion.Windows.Forms.Grid.GridSaveCellInfoEventHandler(this.m_grid_SaveCellInfo);
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(203, 267);
			this.Controls.Add(this.m_grid);
			this.Name = "Form1";
			this.Text = "Form1";
			((System.ComponentModel.ISupportInitialize)(this.m_grid)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		private void m_grid_SaveCellInfo(object sender, Syncfusion.Windows.Forms.Grid.GridSaveCellInfoEventArgs e)
		{
			if( e.ColIndex > 0 && e.RowIndex > 0)
			{
				if (e.ColIndex==1)
				{
					this.m_values[e.RowIndex - 1] = (int)Convert.ChangeType(e.Style.CellValue, m_grid.ColStyles[1].CellValueType);
				}
				else if (e.ColIndex==2)
				{
					int i= e.Style.CellValue.ToString().Trim()==""?9:m_classLookup.IndexOf(m_classLookup[int.Parse(e.Style.CellValue.ToString())]);
					if (i<0) return;
					this.m_values[e.RowIndex - 1] = i==9?9:m_classLookup[i].classNumber;
				}
				e.Handled = true;
			}
		}

		private void m_grid_QueryCellInfo(object sender, Syncfusion.Windows.Forms.Grid.GridQueryCellInfoEventArgs e)
		{
			if(e.ColIndex > 0 && e.RowIndex > 0)
			{
				int value = this.m_values[e.RowIndex - 1];
				if (e.ColIndex==1)
				{
					e.Style.CellValue = value;
				}
				else if (e.ColIndex==2)
				{
					int i=m_classLookup.BinarySearch(value);
					if (i<0) 
						e.Style.CellValue = value.ToString();
					else
						e.Style.CellValue = i;//m_classLookup[i].className;
					
				}
				e.Handled = true;
			}
		}

		private void m_grid_QueryRowCount(object sender, Syncfusion.Windows.Forms.Grid.GridRowColCountEventArgs e)
		{
			e.Count = this.m_values.Length;
			e.Handled = true;
		}
	}

	//--------------------------------------------------------------------------
	public class DClassCodeLookup : IComparable   
	{
		public int    classNumber;
		public string className;
		public int    ClassNumber { get { return classNumber; } }
		public string ClassName   { get { return className; } }
		public DClassCodeLookup(int classNumber, string className) { this.classNumber=classNumber; this.className=className; }
		public DClassCodeLookup(DClassCodeLookup data) { this.classNumber=data.classNumber; this.className=data.className; }
		public int CompareTo(object obj)
		{
			DClassCodeLookup cl = obj as DClassCodeLookup;
			if (cl!=null) return this.classNumber - cl.classNumber;
			string cn = obj as string;
			if (cn!=null) return string.Compare(this.className,cn);
			return this.classNumber - Convert.ToInt32(obj);
		}
	}

	//--------------------------------------------------------------------------
	public class DClassCodeLookupList : ArrayList  //make it appear as a simple array
	{
		public new DClassCodeLookup this[int index] { get { return (DClassCodeLookup)(base[index]); } set { base[index] = value; } }
	}
}
